% RNA TD4 : Comparaison de Modeles et Generalisation
% Auteurs : Soizic Geslin - Maxime Chambreuil
% Date : 10 Mars 2003

close all
clear all

%%%%%%%%%%%%%%%%%
% INITIALISATIONS

heart = load('heart.data');
N = length(heart);
L = 10;
nbTest = N/3;
nbVal = (N-nbTest)/L;
nbApp = N-nbTest-nbVal;
% nbVal = nbTest;
% nbApp = N -2*nbVal;
WStock = [];

%initialisation de la matrice X (valeurs des variables et biais) et du
%vecteur Y (classe d'appartenance)
Y = heart(:,14);
Y(find(Y==2))=-1;

% On centre et on reduit les donnees
X = (heart-repmat(mean(heart),N,1))./repmat(var(heart),N,1);
X(:,14) = ones(length(X),1);

% % Initialisation d un vecteur d indices au hasard de 270 valeurs
indicesMelanges = randperm(N);
% indicesApp = indicesMelanges(1:nbApp);
% indicesVal = indicesMelanges(nbApp+1:nbApp+nbVal);
indicesTest = indicesMelanges(nbApp+nbVal+1:end);

for i=1:L
    
    % % Initialisation d un vecteur d indices au hasard de 180 valeurs
    indicesVal = indicesMelanges((i-1)*(N-nbTest)/L+1:i*(N-nbTest)/L);
    indicesApp = [ indicesMelanges(i*(N-nbTest)/L+1:nbApp+nbVal) indicesMelanges(1:i*(N-nbTest)/L) ];
        
    %%%%%%%%%%%%%%%%
    % Discrimination 
    
    % %% Perceptron
    % % Initialisation
    % nbitemax = 200;
    % pas = 0.00025;
    % [W,cout] = discrimination(nbitemax,pas,X,Y,indicesApp,indicesVal,0,1);
    
    % %% Adaline
    % % Initialisation
    % nbitemax = 200;
    % pas = 0.001;
    % [W,cout] = discrimination(nbitemax,pas,X,Y,indicesApp,indicesVal,0,2);
    
    %% Neurone Formel
    % Initialisation
    nbitemax = 200;
    pas = 0.005;
    [W,cout] = discrimination(nbitemax,pas,X,Y,indicesApp,indicesVal,10,3);
    
    WStock = [WStock W];
    
    %%%%%%%%%%%%%%%%
    % Generalisation 
    
    % %%
    % Valeurs de test
    % Pourcentage de mal classe
    % estimation = sign(X(indicesTest,:)*W);
    
    % nbMalClasse = sum(abs((estimation-Y(indicesTest))/2));
    % fprintf('Pourcentage de mal classe : %.2f\n',nbMalClasse*100/nbTest);
    
    % Erreur quadratique
    % EQM = mean(abs(( estimation-Y(indicesTest) )/2))
    % fprintf('Erreur quadratique moyenne : %.2f\n',EQM);

    % Matrice de confusion
    % matConfu = matriceConfusion(estimation,Y(indicesTest))

end

%% Modele moyen
Wmoyenne = mean(WStock,2);
estimationMoyenne = sign(X(indicesTest,:)*Wmoyenne);

% Matrice de confusion
matConfu = matriceConfusion(estimationMoyenne,Y(indicesTest,:))
   
% Pourcentage de mal classe
nbMalClasse = sum(abs(estimationMoyenne-Y(indicesTest,:))/2);    
fprintf('Pourcentage final de mal classe : %.2f\n',nbMalClasse*100/nbTest);

% Erreur quadratique
EQM = mean(abs((estimationMoyenne-Y(indicesTest,:))/2));
fprintf('Erreur quadratique moyenne finale: %.2f\n',EQM);

