% RNA - TD 4 : Comparaison de Modeles et Generalisation
% Auteurs : Soizic Geslin - Maxime Chambreuil
% Date : 10 Mars 2003

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% EN ENTREE

% nbitemax : Nombre maximal d'iteration
% pas : Pas de l'iteration
% X : matrice 2*n lignes, 3 colonnes (3eme colonne = biais)
% Y : vecteur 2*n lignes , -1 ou 1 selon la classe
% methode : 1 = Perceptron
%           2 = Adaline
%           3 = Neurone formel

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% EN SORTIE

% W : coefficient de la droite de discrimination
% cout : cout 

function [meilleurW,meilleurCout] = discrimination(nbitemax,pas,X,Y,indicesApp,indicesVal,lambda,methode)
k=0;
coutApp = [];
coutVal = [];
cout = 1;
meilleurCout = length(indicesApp)+1;
meilleurW = ones(size(X,2),1);
WApp=randn(size(X,2),1);

while((cout>0) & (k<nbitemax))
        k = k+1;
	indApp = indicesApp(randperm(length(indicesApp)));
        for i = 1:length(indApp)

	   %%%%%%%%%%%% 
	   % Perceptron
           if (methode == 1)
	       %On reprend l algo du gradient
               Dir = (sign(X(indApp(i),:)*WApp)-Y(indApp(i)))*X(indApp(i),:);
           end

	   %%%%%%%%%
	   % Adaline
           if (methode == 2)
	       % c'est la mm chose mais avec psi'=1
                Dir = ( X(indApp(i),:)*WApp - Y(indApp(i)) ) * X(indApp(i),:);
           end
	
	   %%%%%%%%%%%%%%%% 
	   % Neurone formel
           if (methode == 3)
	       %c'est la mm chose mais avec psi=th tangente hyperbolique
	       %th=sh/ch
	       %th'=(ch*ch - sh*sh)/(ch*ch)=1-th*th
	   
               WX = X(indApp(i),:)*WApp;
               TWX = tanh(WX);
               Dir = ( TWX - Y(indApp(i)) ) * (1 - TWX.^2 ) * X(indApp(i),:);
               
           end

           WApp = WApp-pas*Dir';

        end

        cout = sum(abs(sign(X(indicesApp,:)*WApp)-Y(indicesApp)))/2 + lambda*(norm(WApp))^2;
        coutApp = [coutApp cout];
        coutVal = [coutVal sum(abs(sign(X(indicesVal,:)*WApp)-Y(indicesVal)))/2];
        
	if ( meilleurCout - coutVal(k) > 0)
	    meilleureIteration = k;
            meilleurCout = coutVal(k);
      	    meilleurW = WApp;
	end

end

% figure;
% plot (coutApp);
% hold on;
% plot(coutVal,'g');
% hold on;
% plot(meilleureIteration,meilleurCout,'or');
% hold off;

